#include <QByteArray>
#include <QRegExp>
#include <QDebug>
#include <iostream>

QByteArray english() {
    return "Microsoft (R) C/C++ Optimizing Compiler Version 19.00.24215.1 for x64\n"
"Copyright (C) Microsoft Corporation.  All rights reserved.\n"            
"usage: cl [ option... ] filename... [ /link linkoption... ]\n";
}

QByteArray french()
{
    uchar ff = 0xFF;
    QByteArray r = "Compilateur d'optimisation Microsoft (R) C/C++ version";
    r += char(ff);
    r += "19.00.24210 pour x86\n"
"Copyright (C) Microsoft Corporation.  All rights reserved.\n"
"usage: cl [ option... ] filename... [ /link linkoption... ]\n";
    return r;
}

void testF(QByteArray inputB)
{
    // configure has QT_NO_TEXTCODEC, a simple convert from ASCII
    // would otherwise convert \0xff to ' '
    QString input = QString::fromLatin1(inputB);
    qDebug() << __FUNCTION__ << inputB << '\n' << inputB.toHex() << "\nQString: "
             << input;

    QString version;
    QRegExp versionRegexp(QStringLiteral("^.*\\b(\\d{2,2}\\.\\d{2,2}\\.\\d{5,5})\\b.*$"));
    Q_ASSERT(versionRegexp.isValid());
    if (versionRegexp.exactMatch(input)) {
        version = versionRegexp.cap(1);
        qDebug() << "ok" << version;
    } else {
        QDebug d = qDebug();
        d <<  "Unable to determine cl version from the output of \"" << inputB << "\"\n";
        for (int i =0; i < input.size(); ++i) {
            QChar c = input.at(i);
            d << c << c.unicode();
            if (c.isSpace())
                d << "[space]";
            if (c.isPrint())
                d << "[print]";
            if (c.isLetter())
                d << "[letter]";
            d << '\n';
        }
    }
}

int main(int argc, char *argv[])
{
    testF(english());
    testF(french());
    return 0;
}

